
/*********************************************************************
 * Translation of the backtracking program into C,
 * This is from the original BASIC (without using the S array).
 * This file is a replacement for calc.c using no optimisation.
 ********************************************************************/

#include "prog.h"

double
calculate (mindepth, maxdepth, cutoff)
     int mindepth, maxdepth;
     double cutoff;
{

  int a = 0, ap = 0, b = 0, count = 0, rp = 0, rho = 0, D = 0;
  int i = 0, ii = 0;

  count = 0;
  D = 0;
do1:for (;;) {
    if (D == SA) {
      count++;
      b = psi[D];
      D--;
      a = D + 1;
      b = b + 1;
    } else {
      a = D + 1;
      b = 1;
    }
  do2:for (;;) {
      if (b <= SB) {
	rp = 1;
	rho = 0;

	/* Start of DO subroutine: */
	while ((rho < R) && (rp == 1)) {
	  if ((RA[rho][a][a] == 1) && (RB[rho][b][b] == 0)) {
	    rp = 0;
	  }
	  ap = 1;
	  while ((ap <= D) && (rp == 1)) {
	    if ((RA[rho][a][ap] == 1) &&
		(RB[rho][b][psi[ap]] == 0)) {
	      rp = 0;
	    } else if ((RA[rho][ap][a] == 1) &&
		       (RB[rho][psi[ap]][b] == 0)) {
	      rp = 0;
	    }
	    ap++;
	  }                     /* end of inner while loop */
	  rho++;
	}                       /* end outer while loop */
/*
 *        if ((D == SA - 1) && (rp == 1)) {
 *          printf ("C=%3d ", count + 1);
 *          for (ii = 1; ii <= D; ii++) {
 *            printf ("%3d", psi[ii]);
 *          }
 *          printf ("%3d\n", b);
 *        }
 */
	/* end of DO subroutine */

	if (rp == 1) {
	  goto lastdo2;
	}
	b++;
      } else {
	if (D == 0) {
	  goto lastdo1;
	}
	b = psi[D];
	D--;
	a = D + 1;
	b++;
      }
    nextdo2:;
    }                           /* end of do2 loop */
  lastdo2:
    D++;
    psi[D] = b;
  nextdo1:;
  }                             /* end of do1 loop */
lastdo1:;

  printf ("Number of maps found ");
  printf (" = %3d\n", count);

  return (count);
}                               /* End of calculate(mindepth, maxdepth, cutoff) */

int
relpres ()
{
  /* return 1 if current map (psi) preserves relation R, 0 otherwise */
  int i, j, result;

  result = 1;
  for (i = 1; i <= SA; i++) {
    for (j = 1; j <= SA; j++) {
      /* If i and j are related by R in SA
       * then their images must be related by R in SB
       */
      if (RA[R][pi[i]][pi[j]] && !RB[R][psi[i]][psi[j]]) {
	(void) printf ("Elements %i and %i are related in A but %i and %i are not related in B\n", pi[i], pi[j], psi[i], psi[j]);
	result = 0;
      }
    }
  }
  return (result);
}                               /* End of relpres () */
